-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
	electrics.values['shiftknob_H'] = 0
	electrics.values['shiftknob_V'] = 0
end

local function setShiftPosition(h,v)
	--equalize movement
	if v < 0 then v = v * 0.6 end
	
	electrics.values['shiftknob_H'] = h
	electrics.values['shiftknob_V'] = v
end

local function updateGFX(dt)
	local gr = drivetrain.gear
	
	--neutral
	if gr == 0 then setShiftPosition(0.25, 0) return end
	--reverse
	if gr == -1 then setShiftPosition(-0.6, 0.25) return end
	--other gears:
	if gr == 1 then setShiftPosition(-0.40, 0.2) return end
	if gr == 2 then setShiftPosition(0.85, 0.9) return end
	if gr == 3 then setShiftPosition(-0.40, -0.15) return end
	if gr == 4 then setShiftPosition(0.75, 0.1) return end
	if gr == 5 then setShiftPosition(-0.50, -0.7) return end
	if gr == 6 then setShiftPosition(0.60, -0.25) return end
	local vpos = 0
	local hpos = 0
   
	setShiftPosition(hpos,vpos)
end

-- public interface
M.onInit    = onReset
M.onReset   = onReset
M.updateGFX = updateGFX

return M